diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 0f28d5b52..84728a943 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -4,8 +4,8 @@ import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.Particle;
 import net.minecraft.client.entity.particle.ParticleDispatcher;
-import net.minecraft.client.gui.GuiPhotoMode;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.PhotoModeScreen;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.block.model.LeavesBlockModel;
@@ -37,11 +37,13 @@ import net.minecraft.core.world.AuroraProvider;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.lwjgl.opengl.ARBOcclusionQuery;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL15;
 
+import java.awt.*;
 import java.nio.IntBuffer;
 import java.util.ArrayList;
 import java.util.Arrays;
@@ -77,7 +79,7 @@ public class RenderGlobal
     public static final int RENDER_CHUNK_SIZE = 16;
     public static final int RENDER_LIST_BASE_WIDTH = 48;
 
-    public RenderGlobal(Minecraft minecraft, RenderEngine renderengine)
+    public RenderGlobal(Minecraft minecraft, TextureManager textureManager)
     {
         tileEntities = new ArrayList<>();
         chunkRenderersToUpdate = new ArrayList<>();
@@ -94,7 +96,7 @@ public class RenderGlobal
         prevSortZ = -9999D;
         frustumCheckOffset = 0;
         mc = minecraft;
-        renderEngine = renderengine;
+        this.textureManager = textureManager;
         glRenderListBase = GLAllocation.generateDisplayLists(RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * RENDER_LIST_BASE_WIDTH * 3);
         occlusionEnabled = OpenGLHelper.enableOcclusionCheck;
         if(occlusionEnabled)
@@ -348,7 +350,7 @@ public class RenderGlobal
         double rotationX = Math.cos(((cameraYaw * Math.PI) / 180D));
         double rotationZ = Math.sin(((cameraYaw * Math.PI) / 180D));
 
-        renderEngine.bindTexture(renderEngine.loadTexture("/assets/minecraft/textures/environment/aurora.png"));
+        textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/environment/aurora.png"));
         double time = worldObj.getWorldTime() + partialTick;
         AuroraProvider aurora = worldObj.auroraProvider;
 
@@ -410,8 +412,8 @@ public class RenderGlobal
             renderEntitiesStartupCounter--;
             return;
         }
-        BlockEntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, renderEngine, mc.fontRenderer, camera, partialTick);
-        EntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, renderEngine, mc.fontRenderer, camera, mc.gameSettings, partialTick);
+        BlockEntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, textureManager, mc.font, camera, partialTick);
+        EntityRenderDispatcher.instance.cacheActiveRenderInfo(worldObj, textureManager, mc.font, camera, mc.gameSettings, partialTick);
         countEntitiesTotal = 0;
         countEntitiesRendered = 0;
         countEntitiesHidden = 0;
@@ -817,7 +819,7 @@ public class RenderGlobal
 
     public void drawSky(float partialTick)
     {
-        if(!mc.theWorld.getWorldType().hasSky() || mc.currentScreen instanceof GuiModelViewer)
+        if(!mc.theWorld.getWorldType().hasSky() || mc.currentScreen instanceof ModelViewerScreen)
         {
             return;
         }
@@ -884,25 +886,98 @@ public class RenderGlobal
         GL11.glRotatef(celestialAngle * 360F, 0.0F, 0.0F, 1.0F);
 
         // Render sun
-        float f15 = 30F;
-        renderEngine.loadTexture("/terrain/sun.png").bind();
+        float size = 30F;
+        textureManager.loadTexture("/terrain/sun.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
         t.startDrawingQuads();
-        t.addVertexWithUV(-f15, 100D, -f15, 0.0D, 0.0D);
-        t.addVertexWithUV(f15, 100D, -f15, 1.0D, 0.0D);
-        t.addVertexWithUV(f15, 100D, f15, 1.0D, 1.0D);
-        t.addVertexWithUV(-f15, 100D, f15, 0.0D, 1.0D);
+        t.addVertexWithUV(-size, 100D, -size, 0.0D, 0.0D);
+        t.addVertexWithUV(size, 100D, -size, 1.0D, 0.0D);
+        t.addVertexWithUV(size, 100D, size, 1.0D, 1.0D);
+        t.addVertexWithUV(-size, 100D, size, 0.0D, 1.0D);
         t.draw();
 
+        // Render Rainbow
+        if (worldObj.rainbowTicks > 0 || (!Double.isNaN(rainbowBrightness) && rainbowBrightness > 0)){
+            // Calculates the progress through the rainbow, with peak brightness halfway through its lifespawn
+            final float halfRainbowLength = (worldObj.startingRainbowTicks/2f);
+            float rainbowTimeScalar = 1 - (Math.abs((worldObj.rainbowTicks + partialTick) - halfRainbowLength) / halfRainbowLength);
+
+            // Calculates the potential max rainbow brightness based on time of day
+            float timeScalar;
+            float angDeg = celestialAngle * 360;
+            if (angDeg >= 0 && angDeg < 180){
+                double angDiff = MathHelper.deltaAngle(angDeg, 80.0);
+                timeScalar = 1 - (float) (Math.sqrt(angDiff * angDiff) / 90f);
+            } else {
+                double angDiff = MathHelper.deltaAngle(angDeg, 280.0);
+                timeScalar = 1 - (float) (Math.sqrt(angDiff * angDiff) / 90f);
+            }
+
+            // Cutoff zeros out part of the range and then rescales it
+            final float cutoff = 2.25f;
+            timeScalar -= 1 - (1/cutoff);
+            if (timeScalar < 0) timeScalar = 0;
+            timeScalar *= cutoff;
+            timeScalar *= rainbowTimeScalar;
+
+            Weather[] blocked = worldObj.getBlockBiome(MathHelper.floor(mc.thePlayer.x), MathHelper.floor(mc.thePlayer.y), MathHelper.floor(mc.thePlayer.z)).blockedWeathers;
+            boolean isWeatherBlocked = false;
+            for (Weather w : blocked){
+                if (w.equals(worldObj.weatherManager.getLastWeather())) {
+                    isWeatherBlocked = true;
+                    break;
+                }
+            }
+
+            if (isWeatherBlocked){
+                targetRainbowBrightness = 0;
+            } else {
+                targetRainbowBrightness = timeScalar;
+            }
+
+            if (Double.isNaN(rainbowBrightness)) {
+                rainbowBrightness = targetRainbowBrightness;
+            }
+
+            double totalDelta = targetRainbowBrightness - rainbowBrightness;
+            rainbowBrightnessDelta = totalDelta / 100;
+            rainbowBrightness += rainbowBrightnessDelta * partialTick;
+
+            // Draws and colors ring textures to make the rainbow
+            textureManager.loadTexture("/terrain/rainbow.png").bind();
+            t.startDrawingQuads();
+            final int iterations = 10;
+            for (int i = 0; i < iterations; i++) {
+                size = 200F - i * 4;
+                int color = Color.HSBtoRGB(i/(float)iterations, 1, (float) (0.3f * rainbowBrightness));
+                float colR = ((color >> 16) & 0xFF)/255f;
+                float colG = ((color >>  8) & 0xFF)/255f;
+                float colB = ((color >>  0) & 0xFF)/255f;
+                float rainbowAlpha = (float) ((0.35f - (0.15f * Math.abs(i - iterations/2)/(iterations/2f))) * rainbowBrightness);
+                t.setColorRGBA_F(colR, colG, colB, rainbowAlpha);
+                t.addVertexWithUV(-size, -100D, size, 1.0D, 1.0D);
+                t.addVertexWithUV(size, -100D, size, 0.0D, 1.0D);
+                t.addVertexWithUV(size, -100D, -size, 0.0D, 0.0D);
+                t.addVertexWithUV(-size, -100D, -size, 1.0D, 0.0D);
+            }
+            t.draw();
+        } else {
+            rainbowBrightness = 0;
+            rainbowBrightnessDelta = 0;
+            targetRainbowBrightness = 0;
+        }
+
+
+
         // Render moon
-        f15 = 20F;
-        renderEngine.loadTexture("/terrain/moon.png").bind();
+        size = 20F;
+        textureManager.loadTexture("/terrain/moon.png").bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, sunAlpha);
         t.startDrawingQuads();
-        t.addVertexWithUV(-f15, -100D, f15, 1.0D, 1.0D);
-        t.addVertexWithUV(f15, -100D, f15, 0.0D, 1.0D);
-        t.addVertexWithUV(f15, -100D, -f15, 0.0D, 0.0D);
-        t.addVertexWithUV(-f15, -100D, -f15, 1.0D, 0.0D);
+        t.addVertexWithUV(-size, -100D, size, 1.0D, 1.0D);
+        t.addVertexWithUV(size, -100D, size, 0.0D, 1.0D);
+        t.addVertexWithUV(size, -100D, -size, 0.0D, 0.0D);
+        t.addVertexWithUV(-size, -100D, -size, 1.0D, 0.0D);
         t.draw();
 
         GL11.glDisable(GL11.GL_TEXTURE_2D);
@@ -938,7 +1013,7 @@ public class RenderGlobal
         {
             return;
         }
-        if (mc.currentScreen instanceof GuiPhotoMode)
+        if (mc.currentScreen instanceof PhotoModeScreen)
         {
             return;
         }
@@ -952,7 +1027,7 @@ public class RenderGlobal
         byte cloudRadius = 32;
         int i = 256 / cloudRadius;
         Tessellator tessellator = Tessellator.instance;
-        renderEngine.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
+        textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         Vec3 dimensionColor = worldObj.getDimensionColor(mc.activeCamera, partialTick);
@@ -975,10 +1050,10 @@ public class RenderGlobal
         {
             for(int cloudZ = -cloudRadius * i; cloudZ < cloudRadius * i; cloudZ += cloudRadius)
             {
-                tessellator.addVertexWithUV(cloudX + 0,           cloudHeight, cloudZ + cloudRadius, (float)(cloudX + 0)           * f6 + f10, (float)(cloudZ + cloudRadius) * f6 + f11);
+                tessellator.addVertexWithUV(cloudX,           cloudHeight, cloudZ + cloudRadius, (float)(cloudX)           * f6 + f10, (float)(cloudZ + cloudRadius) * f6 + f11);
                 tessellator.addVertexWithUV(cloudX + cloudRadius, cloudHeight, cloudZ + cloudRadius, (float)(cloudX + cloudRadius) * f6 + f10, (float)(cloudZ + cloudRadius) * f6 + f11);
-                tessellator.addVertexWithUV(cloudX + cloudRadius, cloudHeight, cloudZ + 0,           (float)(cloudX + cloudRadius) * f6 + f10, (float)(cloudZ + 0)           * f6 + f11);
-                tessellator.addVertexWithUV(cloudX + 0,           cloudHeight, cloudZ + 0,           (float)(cloudX + 0)           * f6 + f10, (float)(cloudZ + 0)           * f6 + f11);
+                tessellator.addVertexWithUV(cloudX + cloudRadius, cloudHeight, cloudZ,           (float)(cloudX + cloudRadius) * f6 + f10, (float)(cloudZ)           * f6 + f11);
+                tessellator.addVertexWithUV(cloudX,           cloudHeight, cloudZ,           (float)(cloudX)           * f6 + f10, (float)(cloudZ)           * f6 + f11);
             }
 
         }
@@ -1020,7 +1095,7 @@ public class RenderGlobal
         int j = MathHelper.floor(dz / 2048D);
         dx -= i * 2048;
         dz -= j * 2048;
-        renderEngine.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
+        textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         float f13 = 1F / 256F;
@@ -1266,7 +1341,7 @@ public class RenderGlobal
 
     public void drawSelectionBox(ICamera camera, HitResult hitResult, float partialTick)
     {
-        if (mc.gameSettings.immersiveMode.drawOutline() && mc.gameSettings.blockOutlineWidth.value > 0.01f && !(mc.currentScreen instanceof GuiModelViewer))
+        if (mc.gameSettings.immersiveMode.drawOutline() && mc.gameSettings.blockOutlineWidth.value > 0.01f && !(mc.currentScreen instanceof ModelViewerScreen))
         {
             GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
@@ -1475,10 +1550,10 @@ public class RenderGlobal
         Float[] points = volume.getBakedLineCoords();
         for (int i = 0; i < points.length; i += 3)
         {
-            float expand0 = ((points[i + 0] - 0.5f) * 2) * expand;
+            float expand0 = ((points[i] - 0.5f) * 2) * expand;
             float expand1 = ((points[i + 1] - 0.5f) * 2) * expand;
             float expand2 = ((points[i + 2] - 0.5f) * 2) * expand;
-            t.addVertex(points[i + 0] + xOffset + expand0, points[i + 1] + yOffset + expand1, points[i + 2] + zOffset + expand2);
+            t.addVertex(points[i] + xOffset + expand0, points[i + 1] + yOffset + expand1, points[i + 2] + zOffset + expand2);
         }
         t.draw();
     }
@@ -1555,9 +1630,9 @@ public class RenderGlobal
         if(soundPath != null)
         {
             if (author != null && !author.isEmpty()){
-                mc.ingameGUI.setRecordPlayingMessage(author + " - " + I18n.getInstance().translateKey(soundPath));
+                mc.ingameHud.setRecordPlayingMessage(author + " - " + I18n.getInstance().translateKey(soundPath));
             } else {
-                mc.ingameGUI.setRecordPlayingMessage(I18n.getInstance().translateKey(soundPath));
+                mc.ingameHud.setRecordPlayingMessage(I18n.getInstance().translateKey(soundPath));
             }
         }
         mc.sndManager.playMusic(soundPath, x, y, z, 1.0F, 1.0F);
@@ -1567,15 +1642,7 @@ public class RenderGlobal
 	public void playSound(Entity player, String soundPath, SoundCategory category, double x, double y, double z,
                           float volume, float pitch)
     {
-        float soundDistance = 16F;
-        if(volume > 1.0F)
-        {
-            soundDistance *= volume;
-        }
-        if(mc.activeCamera.distanceToSqr(x, y, z) < (double)(soundDistance * soundDistance))
-        {
-            mc.sndManager.playSoundAt(soundPath, category, (float)x, (float)y, (float)z, volume, pitch);
-        }
+        mc.sndManager.playSoundAt(soundPath, category, (float)x, (float)y, (float)z, volume, pitch);
     }
     
     @Override
@@ -1588,7 +1655,7 @@ public class RenderGlobal
 	public void addParticle(String particleId, double x, double y, double z,
                             double motionX, double motionY, double motionZ, int data, double maxDistance)
     {
-        if(mc == null || mc.activeCamera == null || mc.effectRenderer == null) {
+        if(mc == null || mc.activeCamera == null || mc.particleEngine == null) {
             return;
         }
         double d6 = mc.activeCamera.getX() - x;
@@ -1600,7 +1667,7 @@ public class RenderGlobal
         }
         Particle fx = ParticleDispatcher.getInstance().getDispatch(particleId).newParticle(worldObj, x, y, z, motionX, motionY, motionZ, data);
         if (fx != null){
-            mc.effectRenderer.addEffect(fx);
+            mc.particleEngine.add(fx);
         }
     }
     
@@ -1675,7 +1742,7 @@ public class RenderGlobal
 
                     worldObj.playBlockSoundEffect(null, (float)x + 0.5F, (float)y + 0.5F, (float)z + 0.5F, block, EnumBlockSoundEffectType.MINE);
                 }
-                mc.effectRenderer.addBlockDestroyEffects(x, y, z, data, worldObj.getBlockMetadata(x, y, z));
+                mc.particleEngine.destroy(x, y, z, data, worldObj.getBlockMetadata(x, y, z));
                 break;
 
             case EVENT_DOOR_SOUND: // Door sound
@@ -1717,7 +1784,7 @@ public class RenderGlobal
 
     public List<BlockEntity> tileEntities;
     private World worldObj;
-    private final RenderEngine renderEngine;
+    private final TextureManager textureManager;
     private final List<ChunkRenderer> chunkRenderersToUpdate;
     private ChunkRenderer[] sortedChunkRenderers;
     private ChunkRenderer[] chunkRenderers;
@@ -1725,7 +1792,7 @@ public class RenderGlobal
     private int renderChunksTall;
     private int renderChunksDeep;
     private int glRenderListBase;
-    private Minecraft mc;
+    private final Minecraft mc;
     private RenderBlocks globalRenderBlocks;
     private IntBuffer glOcclusionQueryBase;
     private boolean occlusionEnabled;
@@ -1736,8 +1803,8 @@ public class RenderGlobal
     private float cloudVelocityX;
     private float cloudVelocityZ;
     
-    private int starGLCallList;
-    private int glSkyList;
+    private final int starGLCallList;
+    private final int glSkyList;
     private int minBlockX;
     private int minBlockY;
     private int minBlockZ;
@@ -1749,7 +1816,7 @@ public class RenderGlobal
     private int countEntitiesTotal;
     private int countEntitiesRendered;
     private int countEntitiesHidden;
-    int dummyBuf50k[];
+    int[] dummyBuf50k;
     IntBuffer occlusionResult;
     private int renderersLoaded;
     private int renderersBeingClipped;
@@ -1772,4 +1839,8 @@ public class RenderGlobal
     private double auroraBrightness = 0.0f;
     private double targetAuroraBrightness = Double.NaN;
     private double auroraBrightnessDelta = Double.NaN;
+
+    private double rainbowBrightness = 0.0f;
+    private double targetRainbowBrightness = Double.NaN;
+    private double rainbowBrightnessDelta = Double.NaN;
 }
diff --git a/src/main/java/net/minecraft/client/render/RenderEngine.java b/src/main/java/net/minecraft/client/render/TextureManager.java
similarity index 91%
rename from src/main/java/net/minecraft/client/render/RenderEngine.java
rename to src/main/java/net/minecraft/client/render/TextureManager.java
index 3de2fa842..6b60ab460 100644
--- a/src/main/java/net/minecraft/client/render/RenderEngine.java
+++ b/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -13,9 +13,10 @@ import java.util.List;
 import java.util.Map;
 import java.util.Objects;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.popup.GuiPopup;
+import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.colorizer.Colorizers;
@@ -51,9 +52,10 @@ import net.minecraft.core.util.helper.Buffer;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.slf4j.Logger;
 
-public class RenderEngine {
-
+public class TextureManager {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public final Minecraft mc;
 
 	public final Map<Integer, Texture> idToTextureMap = new HashMap<>();
@@ -68,7 +70,7 @@ public class RenderEngine {
 	private boolean clampTexture;
 	private boolean blurTexture;
 
-	public RenderEngine(Minecraft minecraft, TexturePackList texturePacks, GameSettings gameSettings) {
+	public TextureManager(Minecraft minecraft, TexturePackList texturePacks, GameSettings gameSettings) {
 		this.mc = minecraft;
 		
 		this.clampTexture = false;
@@ -79,7 +81,7 @@ public class RenderEngine {
 	}
 	
 	public void initDynamicTextures(List<Throwable> errors) {
-		System.out.println("Initializing Dynamic Textures...");
+		LOGGER.info("Initializing Dynamic Textures...");
 
 		dynamicTextures.clear();
 
@@ -131,7 +133,7 @@ public class RenderEngine {
 		for (AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
 			for (IconCoordinate c : stitcher.textureMap.values()) {
 				if (c.hasMeta("animation")) {
-					System.out.println("Icon '" + c.namespaceId + "' has 'animation' meta!");
+                    LOGGER.debug("Icon '{}' has 'animation' meta!", c.namespaceId);
 					addDynamicTextureOverride(new DynamicTextureCustom(c, c.getMeta("animation", AnimationProperties.class)), true);
 				}
 			}
@@ -161,7 +163,7 @@ public class RenderEngine {
 			idToTextureMap.put(texture.id(), texture);
 			return texture;
 		} catch (Exception e) {
-			e.printStackTrace();
+            LOGGER.error("Failed to create texture for '{}'!", name, e);
 		}
 		return null;
 	}
@@ -271,7 +273,7 @@ public class RenderEngine {
 					updateDynamicTexture(dynamicTexture);
 				}
 			} catch(Exception e){
-				new RuntimeException("Exception while updating dynamic for '" + dynamicTexture.targetTexture.namespaceId + "'. Removing from dynamic texture pool and skipping!", e).printStackTrace();
+                LOGGER.error("Exception while updating dynamic for '{}'. Removing from dynamic texture pool and skipping!", dynamicTexture.targetTexture.namespaceId, e);
 				dynamicTextures.remove(dynamicTexture.targetTexture.namespaceId); // Remove broken texture
 			}
 		}
@@ -292,7 +294,7 @@ public class RenderEngine {
     	
     	refreshTextures(errors);
     	
-        if(errors.size() > 0) {
+        if(!errors.isEmpty()) {
         	String string = createErrorString(errors);
         	
         	if(mc.currentScreen != null) {
@@ -302,36 +304,35 @@ public class RenderEngine {
                 builder.closeOnEsc(0);
                 builder.withMessageBox("what", mc.resolution.scaledHeight - 120, string, Integer.MAX_VALUE);
                 builder.withButtonGroup("ok", new String[] {"gui.options.button.done"}, new int[] {0});
-            	GuiPopup popup = builder.build();
+            	PopupScreen popup = builder.build();
             	
-            	mc.displayGuiScreen(popup);
+            	mc.displayScreen(popup);
         	}else {
         		String[] lines = string.split("\n");
-        		
-        		for(int i=0; i < lines.length; i++) {
-        			mc.ingameGUI.addChatMessage(lines[i]);	
-        		}
+
+                for (String line : lines) {
+                    mc.ingameHud.addChatMessage(line);
+                }
         	}
         }
 	}
 	
 	private String createErrorString(List<Throwable> errors) {
-		if(errors.size() == 0) {
+		if(errors.isEmpty()) {
 			return "";
 		}
 		
     	StringBuilder str = new StringBuilder();
     	
     	int readableErrorCount = 0;
-    	
-    	for(int i=0; i < errors.size(); i++) {
-    		Throwable e = errors.get(i);
-    		if(e instanceof TexturePackException) {
-    			addErrorText(str, e, 0);
-    			readableErrorCount++;
-    		}
-    		e.printStackTrace();
-    	}
+
+        for (Throwable e : errors) {
+            if (e instanceof TexturePackException) {
+                addErrorText(str, e, 0);
+                readableErrorCount++;
+            }
+			LOGGER.error("Unexpected Exception", e);
+        }
     	
     	if(readableErrorCount == 0) {
     		str.append("An unexpected error has occurred! Check the log for more information!");
@@ -345,7 +346,7 @@ public class RenderEngine {
 			str.append(' ');
 		}
 		
-		str.append(e.getMessage() + "\n");
+		str.append(e.getMessage()).append("\n");
 		
 		Throwable cause = e.getCause();
 		if(cause instanceof TexturePackException) {
@@ -365,7 +366,7 @@ public class RenderEngine {
 		for (AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
 			stitcher.preinit();
 		}
-		System.out.println("Took '" + (System.nanoTime() - start)/1_000_000_000d + "' seconds to load atlases.");
+        LOGGER.debug("Took '{}' seconds to load atlases.", (System.nanoTime() - start) / 1_000_000_000d);
 
 		initDynamicTextures(errors);
 
@@ -386,7 +387,7 @@ public class RenderEngine {
 
 		Colors.loadColors();
 		
-		mc.fontRenderer = new FontRenderer(mc, gameSettings, "/font/default.png", this);
+		mc.font = new Font(mc, gameSettings, this);
 		
 		mc.skinVariantList.refresh(errors);
 		mc.mainMenuBackground.refresh(errors);
